[Codeforces]856C - Eleventh Birthday

题目大意:给出n个数,问有多少种排列把数字接起来是11的倍数。(n<=2000)

做法:一个数后面接一个数等同于乘上10的若干次幂然后加上这个数,10模11等于-1,所以10的若干次幂是-1或1,根据这个把长度奇和偶的分开考虑,他们最后对和的贡献都是可以确定的几段正几段负,f[i][j][k]表示前i个长度为奇/偶的数,j个贡献为负,对和的贡献为k的方案数,最后再排列组合比较容易可以算出答案,复杂度O(11*n^2)。

代码:

#include<cstdio>
#include<cstring>
inline int read()
{
    int x;char c;
    while((c=getchar())<‘0‘||c>‘9‘);
    for(x=c-‘0‘;(c=getchar())>=‘0‘&&c<=‘9‘;)x=x*10+c-‘0‘;
    return x;
}
#define MN 2000
#define MOD 998244353
int a[MN+5],an,b[MN+5],bn,C[MN+5][MN+5],f1[MN+5][MN+5][11],f2[MN+5][MN+5][11],v[100],p[MN+5];
inline int mod(int x){return x<MOD?x:x-MOD;}
inline int f(int n,int m){return m?1LL*p[n]*C[n+m-1][m-1]%MOD:n?0:1;}
int main()
{
    int T,n,i,j,k,x,ans;
    for(p[0]=i=1;i<=MN;++i)p[i]=1LL*p[i-1]*i%MOD;
    for(i=0;i<=MN;++i)for(C[i][0]=j=1;j<=i;++j)C[i][j]=mod(C[i-1][j-1]+C[i-1][j]);
    for(i=0;i<100;++i)v[i]=i%11;
    for(T=read();T--;)
    {
        n=read();an=bn=0;
        for(;n--;(j&1?a[++an]:b[++bn])=x%11)for(k=x=read(),j=0;k;k/=10)++j;
        for(f1[0][0][0]=1,i=1;i<=an;++i)for(j=0;j<=an/2;++j)for(k=0;k<11;++k)
            f1[i][j][k]=mod((j?f1[i-1][j-1][v[k+a[i]]]:0)+f1[i-1][j][v[k+11-a[i]]]);
        for(f2[0][0][0]=1,i=1;i<=bn;++i)for(j=0;j<=bn;++j)for(k=0;k<11;++k)
            f2[i][j][k]=mod((j?f2[i-1][j-1][v[k+b[i]]]:0)+f2[i-1][j][v[k+11-b[i]]]);
        for(j=0;j<11;++j)f1[an][an/2][j]=1LL*f1[an][an/2][j]*p[an/2]%MOD*p[an-an/2]%MOD;
        for(ans=i=0;i<=bn;++i)for(j=0;j<11;++j)
            ans=(ans+1LL*f1[an][an/2][j]*f2[bn][i][v[11-j]]%MOD*f(i,(an+1)/2)%MOD*f(bn-i,an+1-(an+1)/2))%MOD;
        printf("%d\n",ans);
    }
}
时间: 2024-08-27 17:51:26

[Codeforces]856C - Eleventh Birthday的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ